{--------------------------------------------------------}
{
{    Calculadora Vocal - versao 4.0
{
{    Mdulo de exibio da ajuda
{
{    Autor: Jose' Antonio Borges
{           Mara Lucia Caldeira
{           Julio Tadeu Carvalho da Silveira
{
{    Verso 4.0 em maio/2019
{
{--------------------------------------------------------}

unit calajuda;

interface
uses dvcrt, dvwin, dvform, calvars, calmsg;

procedure mostraCalc;
procedure mostraFuncoes;
procedure mostraTrigonom;

function  menuCalc: char;
function  menuFuncoes: char;
procedure menuTrigonom (var c, c2: char);

implementation

uses caltela;

{--------------------------------------------------------}

procedure mostraCalc;
begin
    window (45, 3, 80, 25);
    clrscr;

    window (1, 1, 80, 25);
    gotoxy (45, 3);
    writeln ('Funes bsicas: +-*/ % \ ( ) =');
    gotoxy (45, 5);
    writeln ('F  Funes matemticas');
    gotoxy (45, 6);
    writeln ('T  Funes trigonomtricas');
    gotoxy (45, 7);
    writeln ('X  Calcula expresso');

    gotoxy (45, 9);
    writeln ('BS apaga dgito');
    gotoxy (45, 10);
    writeln ('C  limpa conta');
    gotoxy (45, 11);
    writeln ('D  nmero de casas decimais');
    gotoxy (45, 12);
    writeln ('P  pe  na memria (0..9, A..Z)');
    gotoxy (45, 13);
    writeln ('M  traz da memria (0..9, A..Z)');
    window (1, 1, 80, 25);
end;

{--------------------------------------------------------}

procedure mostraFuncoes;
label inicia;
begin
inicia:
    window (45, 3, 80, 25);
    clrscr;

    window (47, 3, 80, 25);
    clrscr;
    writeln ('FUNES MATEMTICAS');
    writeln;
    writeln ('  R = resto');
    writeln ('  I = inverso');
    writeln ('  O = oposto');
    writeln ('  T = truncar');
    writeln ('  A = arredondar');
    writeln ('  F = fracionria');
    writeln;
    writeln ('  P = nmero pi');
    writeln ('  E = nmero de Neper');
    writeln ('  L = log');
    writeln ('  N = log neperiano');
    writeln ('  ! = fatorial');
    writeln ('  ^ = elevado a');
    writeln ('  \ = raiz ensima');

    window (1, 1, 80, 25);
end;

{--------------------------------------------------------}

procedure mostraTrigonom;
begin
    window (45, 3, 80, 25);
    clrscr;

    window (47, 3, 80, 25);
    writeln ('FUNES TRIGONOMTRICAS');
    writeln;
    writeln ('  S  = sin');
    writeln ('  C  = cos');
    writeln ('  T  = tan');
    writeln ('  G  = ngulos em graus');
    writeln ('  R  = ngulos em radianos');    //grau para radiano');
    writeln ('  AS = arcsin');
    writeln ('  AC = arccos');
    writeln ('  AT = arctan');
    writeln ('  HS = sinh');
    writeln ('  HC = cosh');
    writeln ('  HT = tanh');
    writeln ('  IS = sinh -1');
    writeln ('  IC = cosh -1');
    writeln ('  IT = tanh -1');

    window (1, 1, 80, 25);
end;

{--------------------------------------------------------}

procedure menuAdiciona (f: string);
begin
    popupMenuAdiciona (f, pegaTextoMensagem (f));
end;

{--------------------------------------------------------}

function menuCalc: char;
var
    n: integer;
const
    tabLetras: string =  '+-*/%\=' + ^8 + 'CDFTX()PM';
begin
    popupMenuCria (xmens, 4, 80-xmens-2, length(tabLetras), RED);
    menuAdiciona ('CA_OP_SOMAR');     {'+   somar'}
    menuAdiciona ('CA_OP_SUBTR');     {'-   subtrair'}
    menuAdiciona ('CA_OP_MULTIP');    {'*   multiplicar'}
    menuAdiciona ('CA_OP_DIVIDIR');   {'/   dividir'}
    menuAdiciona ('CA_OP_PERCENT');   {'%   porcentagem'}
    menuAdiciona ('CA_OP_RAIZ_2');    {'\   raiz quadrada'}
    menuAdiciona ('CA_OP_IGUAL');     {'=   igual'}
    menuAdiciona ('CA_OP_LIMPDIG');   {'backspace  limpa dgito'}
    menuAdiciona ('CA_OP_LIMPCONT');  {'C   limpa conta'}
    menuAdiciona ('CA_OP_NUM_CDEC');  {'D   nmero de casas decimais'}
    menuAdiciona ('CA_OP_FUNC_M');    {'F   Funes matemticas'}
    menuAdiciona ('CA_OP_FUNC_T');    {'T   Funes trigonomtricas'}
    menuAdiciona ('CA_OP_FUNC_X');    {'X   Calcula expresso'}
    menuAdiciona ('CA_OP_ABRESUB');   {'(   abre sub-expresso'}
    menuAdiciona ('CA_OP_FECHASUB');  {')   fecha sub-expresso'}
    menuAdiciona ('CA_OP_POEMEMO');   {'P   pe na memria'}
    menuAdiciona ('CA_OP_RECMEMO');   {'M   recupera da memria'}

    n := popupMenuSeleciona;
    if (n <= 0) or (n > length(tabLetras)) then
        result := ' '
    else
        result := tabLetras[n];
end;

{--------------------------------------------------------}

function menuFuncoes: char;
var n: integer;
const
    tabLetras: string = 'RIOTAFPELN!^\';
begin
    popupMenuCria (xmens, 4, 80-xmens-2, length(tabLetras), RED);
    menuAdiciona ('CA_OP_RESTO');     {'R  resto'}
    menuAdiciona ('CA_OP_INVERSO');   {'I  inverso'}
    menuAdiciona ('CA_OP_OPOSTO');    {'O  oposto'}
    menuAdiciona ('CA_OP_TRUNCAR');   {'T  truncar'}
    menuAdiciona ('CA_OP_ARREND');    {'A  arredondar'}
    menuAdiciona ('CA_OP_P_FRAC');    {'F  parte fracionria'}
    menuAdiciona ('CA_OP_NUM_PI');    {'P  nmero pi'}
    menuAdiciona ('CA_OP_NUM_E');     {'E  nmero de Neper'}
    menuAdiciona ('CA_OP_LOG');       {'L  logaritmo decimal'}
    menuAdiciona ('CA_OP_LOG_E');     {'N  logaritmo neperiano'}
    menuAdiciona ('CA_OP_FATORIAL');  {'!  fatorial'}
    menuAdiciona ('CA_OP_ELEV_A');    {'^  elevado a'}
    menuAdiciona ('CA_OP_RAIZ_N');    {'\  raiz ensima'}

    n := popupMenuSeleciona;
    if (n <= 0) or (n > length(tabLetras)) then
        result := ' '
    else
        result  := tabLetras[n];
end;

{--------------------------------------------------------}

procedure menuTrigonom (var c, c2: char);
var 
    n: integer;
const
    tabLetras:  string = 'SCTGRAAAHHHIII';
    tabLetras2: string = '     SCTSCHSCT';
begin
    popupMenuCria (xmens, 4, 80-xmens-2, length(tabLetras), RED);
    menuAdiciona ('CA_OP_SEN');    {'S   seno'}
    menuAdiciona ('CA_OP_COS');    {'C   cossseno'}
    menuAdiciona ('CA_OP_TAN');    {'T   tangente'}
    menuAdiciona ('CA_OP_GRAU');   {'G   ngulos em graus'}
    menuAdiciona ('CA_OP_RAD');    {'R   ngulos em radianos'}
    menuAdiciona ('CA_OP_ASEN');   {'AS  arco seno'}
    menuAdiciona ('CA_OP_ACOS');   {'AC  arco cosseno'}
    menuAdiciona ('CA_OP_ATAN');   {'AT  arco tangente'}
    menuAdiciona ('CA_OP_SENH');   {'HS  seno hiperblico'}
    menuAdiciona ('CA_OP_COSH');   {'HC  cosseno hiperblico'}
    menuAdiciona ('CA_OP_TANH');   {'HT  tangente hiperblico'}
    menuAdiciona ('CA_OP_ASINH');  {'IS  arco seno hiperblico'}
    menuAdiciona ('CA_OP_ACOSH');  {'IC  arco cossseno hiperblico'}
    menuAdiciona ('CA_OP_ATANH');  {'IT  arco tangente hiperblico'}

    n := popupMenuSeleciona;
    if (n <= 0) or (n > length(tabLetras)) then
        begin
            c := ' ';
            c2 := ' ';
        end
    else
        begin
            c  := tabLetras[n];
            c2 := tabLetras2[n];
        end;
end;

end.

